作者: KSkun

[HAOI2006]数字序列 题解

[HAOI2006]数字序列 题解

题目地址:洛谷:【P2501】[HAOI2006]数字序列 – 洛谷、BZOJ 

[HAOI2008]木棍分割 题解

[HAOI2008]木棍分割 题解

题目地址:洛谷:【P2511】[HAOI2008]木棍分割 – 洛谷、BZOJ 

[HAOI2008]硬币购物 题解

[HAOI2008]硬币购物 题解

题目地址:洛谷:【P1450】[HAOI2008]硬币购物 – 洛谷、BZOJ:Problem 1042. — [HAOI2008]硬币购物

题目描述

硬币购物一共有4种硬币。面值分别为c1,c2,c3,c4。某人去商店买东西,去了tot次。每次带di枚ci硬币,买si的价值的东西。请问每次有多少种付款方法。

输入输出格式

输入格式:
第一行 c1,c2,c3,c4,tot 下面tot行 d1,d2,d3,d4,s

输出格式:
每次的方法数

输入输出样例

输入样例#1:

1 2 5 10 2
3 2 3 1 10
1000 2 2 2 900

输出样例#1:

4
27

说明

di,s<=100000
tot<=1000
[HAOI2008]

题解

每次询问对着跑一遍背包并不现实,所以我们换一种思路。我们预处理不带硬币限制的背包方案数,并且考虑一个容斥的思路。假如不带限制的答案是$dp[s]$,第$i$种硬币限制了$d_i$个,那么从$d_i+1$往后的所有方案都是不可行的,因此要从不带限制的答案中减去一个$dp[s – c_i(d_i+1)]$。这样的话,会减重两个硬币都超了的方案,因此要加上$dp[s – c_i(d_i+1) – c_j(d_j+1)]$,以此类推。
复杂度$O(4 \times 100000 + tot \cdot 2^4)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

int c[5], d[5], tot, s, cnt[1 << 4 + 5];
LL dp[MAXN];

int main() {
    for(int i = 1; i < 1 << 4; i++) {
        cnt[i] = cnt[i >> 1] + (i & 1);
    }
    for(int i = 1; i <= 4; i++) {
        c[i] = readint();
    }
    dp[0] = 1;
    for(int i = 1; i <= 4; i++) {
        for(int j = c[i]; j < MAXN; j++) {
            dp[j] += dp[j - c[i]];
        }
    }
    tot = readint();
    while(tot--) {
        for(int i = 1; i <= 4; i++) {
            d[i] = readint();
        }
        s = readint();
        LL ans = dp[s];
        for(int i = 1; i < 1 << 4; i++) {
            int neg = (cnt[i] & 1) ? -1 : 1;
            int res = 0;
            for(int j = 1; j <= 4; j++) {
                if(i & (1 << (j - 1))) {
                    res += c[j] * (d[j] + 1);
                }
            }
            if(s >= res) ans += neg * dp[s - res];
        }
        printf("%lld\n", ans);
    }
    return 0;
}
[ZJOI2008]骑士 题解

[ZJOI2008]骑士 题解

题目地址:洛谷:【P2607】[ZJOI2008]骑士 – 洛谷、BZOJ:P 

[ZJOI2008]生日聚会 题解

[ZJOI2008]生日聚会 题解

题目地址:洛谷:【P2592】[ZJOI2008]生日聚会 – 洛谷、BZOJ 

[ZJOI2008]泡泡堂 题解

[ZJOI2008]泡泡堂 题解

题目地址:洛谷:【P2587】[ZJOI2008]泡泡堂 – 洛谷、BZOJ:Problem 1034. — [ZJOI2008]泡泡堂BNB

题目描述

第XXXX届NOI期间,为了加强各省选手之间的交流,组委会决定组织一场省际电子竞技大赛,每一个省的代表队由n名选手组成,比赛的项目是老少咸宜的网络游戏泡泡堂。每一场比赛前,对阵双方的教练向组委会提交一份参赛选手的名单,决定了选手上场的顺序,一经确定,不得修改。比赛中,双方的一号选手,二号选手……,n号选手捉对厮杀,共进行n场比赛。每胜一场比赛得2分,平一场得1分,输一场不得分。最终将双方的单场得分相加得出总分,总分高的队伍晋级(总分相同抽签决定)。
作为浙江队的领队,你已经在事先将各省所有选手的泡泡堂水平了解的一清二楚,并将其用一个实力值来衡量。为简化问题,我们假定选手在游戏中完全不受任何外界因素干扰,即实力强的选手一定可以战胜实力弱的选手,而两个实力相同的选手一定会战平。由于完全不知道对手会使用何种策略来确定出场顺序,所以所有的队伍都采取了这样一种策略,就是完全随机决定出场顺序。
当然你不想这样不明不白的进行比赛。你想事先了解一下在最好与最坏的情况下,浙江队最终分别能得到多少分。

题意简述

你和对手都有一队人,每边$n$个人。现在要求让你和对手的队伍两两对决,能力值高的一方获胜,得2分,若能力值相等平局,得1分,否则不得分。求出所有对决的设计中,你的最高可能得分与最低可能得分是多少。

输入输出格式

输入格式:
输入文件的第一行为一个整数n,表示每支代表队的人数。
接下来n行,每行一个整数,描述了n位浙江队的选手的实力值。
接下来n行,每行一个整数,描述了你的对手的n位选手的实力值。

输出格式:
输入文件中包括两个用空格隔开的整数,分别表示浙江队在最好与最坏的情况下分别能得多少分。不要在行末输出多余的空白字符。

输入输出样例

输入样例#1:

2
1
3
2
4

输出样例#1:

2 0

输入样例#2:

6
10000000
10000000
10000000
10000000
10000000
10000000
0
0
0
0
0
0

输出样例#2:

12 12

说明

样例说明
1: 我们分别称4位选手为A,B,C,D。则可能出现以下4种对战方式,最好情况下可得2分,最坏情况下得0分。
一 二 三 四
浙江 ??? 结果 浙江 ??? 结果 浙江 ??? 结果 浙江 ??? 结果
一号选手 A C 负 A D 负 B C 胜 B D 负
二号选手 B D 负 B C 胜 A D 负 A C 负
总得分 0 2 2 0
2: 对手都是认真学习的好孩子,不会打游戏。无论如何排列出场顺序都无法改变被蹂躏的结果。浙江队总能取得全胜的结果。

20%的数据中,1<=n<=10;
40%的数据中,1<=n<=100;
60%的数据中,1<=n<=1000;
100%的数据中,1<=n<=100000,且所有选手的实力值在0到10000000之间。

题解

贪心,我们想到了田忌赛马的模型,即用自己强的打对手强的,如果打不过就用一个最弱的送死。但是这种策略是有漏洞的,有可能拿去送死的最弱的可以将对手的最弱的打败,从而多获得2分,因此我们把这种情况也加入判断。
修改后的策略是,如果我方最强能赢对方最强,则进行这种对决;否则我方最弱如果能赢对方最弱,则以弱对弱;前两种情况都处理完了,再把一个最弱的拿去送死。
最低分数可以直接让对方跑一遍这个策略,然后用总得分减掉对方的最优得分即可。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

int n, slf[MAXN], opp[MAXN], ls, rs, lo, ro;

int main() {
    n = readint();
    for(int i = 1; i <= n; i++) {
        slf[i] = readint();
    }
    for(int i = 1; i <= n; i++) {
        opp[i] = readint();
    }
    std::sort(slf + 1, slf + n + 1);
    std::sort(opp + 1, opp + n + 1);
    int ans1 = 0, ans2 = 0;
    ls = lo = 1; rs = ro = n;
    while(ls <= rs) { 
        if(slf[rs] > opp[ro]) {
            ans1 += 2; rs--; ro--;
        } else if(slf[ls] > opp[lo]) {
            ans1 += 2; ls++; lo++;
        } else {
            ans1 += (slf[ls] == opp[ro]);
            ls++; ro--;
        }
    }
    ls = lo = 1; rs = ro = n;
    while(ls <= rs) {
        if(opp[ro] > slf[rs]) {
            ans2 += 2; rs--; ro--;
        } else if(opp[lo] > slf[ls]) {
            ans2 += 2; ls++; lo++;
        } else {
            ans2 += (opp[lo] == slf[rs]);
            lo++; rs--;
        }
    }
    printf("%d %d", ans1, 2 * n - ans2);
    return 0;
}
[JSOI2007]麻将 题解

[JSOI2007]麻将 题解

题目地址:洛谷:【P4050】[JSOI2007]麻将 – 洛谷、BZOJ:P 

[SHOI2008]循环的债务 题解

[SHOI2008]循环的债务 题解

题目地址:洛谷:【P4026】[SHOI2008]循环的债务 – 洛谷、BZO 

Codeforces Round #495 (Div. 2) 赛后总结

Codeforces Round #495 (Div. 2) 赛后总结

比赛地址:Dashboard – Codeforces Round #495 (Div. 2) – Codeforces
官方题解:Codeforces Round #495 (Div. 2) — Editorial – Codeforces

1004A Sonya and Hotels

题意简述

一维空间坐标轴上有$n$个整点位置修建了酒店,现在想在一个未建酒店的整点位置修一个新酒店,要求新酒店离最近的酒店的距离等于$d$,求新酒店可以选择的坐标数量。
数据范围:$1 \leq 100, 1 \leq d \leq 10^9$

思路

枚举每两个酒店之间的距离,$距离=2d$的时候对答案有1的贡献,$>2d$的时候有2的贡献,首尾各有1的贡献,统计一下就好。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 105;

int n, d, x[MAXN];

int main() {
    n = readint(); d = readint();
    for(int i = 1; i <= n; i++) {
        x[i] = readint();
    }
    int ans = 2;
    for(int i = 2; i <= n; i++) {
        if(x[i] - x[i - 1] == 2 * d) ans++;
        if(x[i] - x[i - 1] > 2 * d) ans += 2;
    }
    printf("%d", ans);
    return 0;
}

1004B Sonya and Exhibition

题意简述

要放$n$盆花成一排,每个位置有两种选择,有$m$个人参观这些花,他们会参观一个连续区间的花,参观的美丽度定义为区间两种花的个数的乘积,求安排方案使得美丽度之和最大。
数据范围:$1 \leq n, m \leq 10^3$

思路

$$ n^2 > (n+1)(n-1) > (n+2)(n-2) > \cdots $$
因此我们可以直接输出一个类似0101010101010101这样的序列就好了。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 1005;

int n, m, l[MAXN], r[MAXN];

int main() {
    n = readint(); m = readint();
    for(int i = 1; i <= m; i++) {
        l[i] = readint(); r[i] = readint();
    }
    LL sum1 = 0, sum2 = 0;
    for(int i = 1; i <= m; i++) {
        int cnt1[2] = {0, 0}, cnt2[2] = {0, 0};
        for(int j = l[i]; j <= r[i]; j++) {
            cnt1[j & 1]++;
            cnt2[(j & 1) ^ 1]++;
        }
        sum1 += 1ll * cnt1[0] * cnt1[1];
        sum2 += 1ll * cnt2[0] * cnt2[1];
    }
    if(sum1 > sum2) {
        fprintf(stderr, "%lld\n", sum1);
        for(int i = 1; i <= n; i++) {
            putchar('0' + (i & 1));
        }
    } else {
        fprintf(stderr, "%lld\n", sum2);
        for(int i = 1; i <= n; i++) {
            putchar('0' + ((i & 1) ^ 1));
        }
    }
    return 0;
}

1004C Sonya and Robots

题意简述

有一个长为$n$的序列,两个机器人从序列的两段开始相向而行,遇到第一个与机器人中存储的数字相同的数字时就在该位置停下,你可以给机器人写入不同的数字,求让它们不相遇的数字对数。
数据范围:$1 \leq n \leq 10^5$

思路

我们从左向右扫这个序列,对于一个之前没有出现过的数字,显然它会与后面的不重复数字产生贡献,那么答案就是这些贡献的和。我们只需要知道一个位置的后面是否还有与这个位置相同的数字,动态地维护后面的不重复数字种数以及前面出现过哪些数字就可以了。
复杂度$O(n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

int n, a[MAXN], nxt[MAXN], head[MAXN];
bool vis[MAXN];

int main() {
    n = readint();
    int cnt = 0;
    LL ans = 0;
    for(int i = 1; i <= n; i++) {
        a[i] = readint();
        if(!vis[a[i]]) {
            vis[a[i]] = true;
            head[a[i]] = i;
            cnt++;
        } else {
            nxt[head[a[i]]] = i;
            head[a[i]] = i;
        }
    }
    memset(vis, 0, sizeof(vis));
    for(int i = 1; i <= n; i++) {
        if(!nxt[i]) {
            cnt--;
        }
        if(!vis[a[i]]) ans += cnt;
        vis[a[i]] = true;
    }
    printf("%lld", ans);
    return 0;
}

1004D Sonya and Matrix

题意简述

有一个矩阵,矩阵中有1个权值为0的格子,而其他格子的权值为到0权格子的曼哈顿距离。现在给你一个长为$t$的序列,是一个包含某一个矩阵里面的所有权值的乱序可重排列。现在你要求出原来矩阵的大小$n \times m$以及0权的位置$(x, y)$。
数据范围:$1 \leq t \leq 10^6$

思路

首先,我们可以用序列统计每个数字出现的次数。在完整的图形中,我们会发现每个数字形成了菱形或者说正方形的形状,如下所示。

          5
        5 4 5
      5 4 3 4 5
    5 4 3 2 3 4 5
  5 4 3 2 1 2 3 4 5
5 4 3 2 1 0 1 2 3 4 5
  5 4 3 2 1 2 3 4 5
    5 4 3 2 3 4 5
      5 4 3 4 5
        5 4 5
          5

我们可以求出序列中的最大数字以及最大的在矩阵中完整地出现了它的菱形的数字,显然,最大数字应该在角上,由于图形的对称性,四个角是等价的,我们暂且让它在左上角$(1, 1)$。
当我们发现矩形的大小并无法让0与最大数共存的时候,显然情况不合法,这种情况的判断,我们可以使用对角线曼哈顿距离(即图形中的最长曼哈顿距离)来判断,即$n+m-2 < mx$时不合法。
另外的不合法情况就是当确定了$n, m, x, y$以后,我们可以计算出最大的整个菱形都包含进来的数字,这个数字是$\min \{ x-1, y-1, n-x, m-y \}$,再把不合法的情况扔掉就好。
剩下的合法情况已经很少了,我们直接暴力$O(t)$地验证就好。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>
#include <cmath>

#include <algorithm>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 1000005;

int t, mx, cnt[MAXN], cnt2[MAXN];

inline int border(int n, int m, int x, int y) {
    return std::min(std::min(x - 1, y - 1), std::min(n - x, m - y));
}

inline bool check(int n, int m, int x, int y) {
    memset(cnt2, 0, sizeof(cnt2));
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cnt2[abs(x - i) + abs(y - j)]++;
        }
    }
    for(int i = 1; i <= t; i++) {
        if(cnt2[i] != cnt[i]) return false;
    }
    return true;
}

int main() {
    t = readint();
    for(int i = 1; i <= t; i++) {
        int a = readint();
        cnt[a]++;
        mx = std::max(mx, a);
    }
    int lim = 0;
    for(int i = 1; i <= t; i++) {
        if(cnt[i] != i * 4) {
            lim = i - 1; break;
        }
    }
    for(int n = 1; n * n <= t; n++) {
        if(t % n) continue;
        int m = t / n;
        if(n + m - 2 < mx) continue;
        for(int j = 1; j <= n; j++) {
            int k = mx - j + 2;
            if(k > m || k < 1) continue;
            if(border(n, m, j, k) != lim) continue;
            if(check(n, m, j, k)) {
                printf("%d %d\n%d %d", n, m, j, k);
                return 0;
            }
        }
    }
    puts("-1");
    return 0;
}

1004E Sonya and Ice Cream

题意简述

给你一棵$n$个点的树,要求从中选出一条不超过$k$个点的路径,使得树的其他点到这条路径的最短距离最大值最小。
数据范围:$1 \leq k \leq n \leq 10^5$

思路

首先,我们可以证明,这条路径在包含树的中心点的时候比较优,中心点定义为到这个点最远的点距离最小的点,显然,这个点应该在直径的中心位置,可以$O(n)$求出来。
答案具有二分性质,所以我们二分答案,接着考虑如何验证。我们可以从中心点开始DFS,每次扩展出去一个点,如果发现一个点的子树中最远的点到它的距离大于答案,则这个点一定要被加入路径。如果一个点有多个儿子一定要被加入路径(中心点特殊考虑,它允许有2个儿子必须被加入路径)则不合法。如果必须被加入路径的点数多于$k$则不合法,判断一下就好。
复杂度$O(n \log n)$。

代码

// Code by KSkun, 2018/7
#include <cstdio>
#include <cctype>
#include <cstring>

#include <algorithm>
#include <vector>

typedef long long LL;

inline char fgc() {
    static char buf[100000], *p1 = buf, *p2 = buf;
    return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
        ? EOF : *p1++;
}

inline LL readint() {
    register LL res = 0, neg = 1; register char c = fgc();
    for(; !isdigit(c); c = fgc()) if(c == '-') neg = -1;
    for(; isdigit(c); c = fgc()) res = (res << 1) + (res << 3) + c - '0';
    return res * neg;
}

const int MAXN = 100005;

struct Edge {
    int to, w;
};
std::vector<Edge> gra[MAXN];

int n, k, du, dv, ct, fa[MAXN], dis[MAXN];

inline void dfs_dis(int u) {
    for(auto e : gra[u]) {
        if(e.to == fa[u]) continue;
        dis[e.to] = dis[u] + e.w;
        fa[e.to] = u;
        dfs_dis(e.to);
    }
}

inline void diameter() {
    dfs_dis(1);
    for(int i = 1; i <= n; i++) {
        if(dis[i] > dis[du]) du = i;
    }
    dis[du] = 0;
    memset(fa, 0, sizeof(fa));
    dfs_dis(du);
    for(int i = 1; i <= n; i++) {
        if(dis[i] > dis[dv]) dv = i;
    }
}

inline void center() {
    for(int i = dv; i; i = fa[i]) {
        if(std::max(dis[ct], dis[dv] - dis[ct]) > std::max(dis[i], dis[dv] - dis[i])) {
            ct = i;
        }
    }
}

int cnt;
bool success;

inline int dfs_check(int u, int fa, int lim) {
    int res = 0, big = 0;
    for(auto e : gra[u]) {
        if(e.to == fa) continue;
        int dis = dfs_check(e.to, u, lim);
        if(dis != -1 && dis + e.w > lim) {
            cnt++; big++;
        }
        if(dis == -1) big++;
        else res = std::max(res, dis + e.w);
    }
    if((u == ct && big > 2) || (u != ct && big > 1)) {
        success = false;
    }
    if(big || u == ct) {
        cnt++; return -1;
    }
    return res;
}

inline bool check(int mid) {
    cnt = 0; success = true;
    dfs_check(ct, 0, mid);
    return success && cnt <= k;
}

int main() {
    n = readint(); k = readint();
    for(int i = 1, u, v, w; i < n; i++) {
        u = readint(); v = readint(); w = readint();
        gra[u].push_back(Edge {v, w});
        gra[v].push_back(Edge {u, w});
    }
    diameter(); center();
    int l = -1, r = 1e9, mid;
    while(r - l > 1) {
        mid = (l + r) >> 1;
        if(check(mid)) r = mid; else l = mid;
    }
    printf("%d", r);
    return 0;
}

1004F Sonya and Bitwise OR

题意简述

维护一个长为$n$的序列,有$m$次操作,支持两种操作

  1. 单点修改
  2. 区间询问有多少连续子序列的异或和不小于$x$(对于所有的询问$x$都相同)

数据范围:$1 \leq n, m \leq 10^5$

思路

咕咕咕。

代码

咕咕咕。

数学笔记:康托展开

数学笔记:康托展开

康托展开(Cantor Expansion) 概述及流程 利用康托展开,我们可以求出一个排